config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  get "movies", to: "movies#index", as: :movies_index
  get "ranking", to: "movies#ranking", as: :movies_ranking
  get "ranking/:episode", to: "movies#details", as: :movies_details


  post "vote", to: "votes#vote"

  root to: "movies#index"

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/movie.rb
class Movie < ApplicationRecord
    self.primary_key = 'id'
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/vote.rb
class Vote < ApplicationRecord
    belongs_to :user
    belongs_to :movie

    validates :movie_id, presence: true, numericality: { only_integer: true }
    validates :vote_type, presence: true
    validate :vote_type_valid

    def vote_type_valid
        if !VotePolicies.valid_type?(vote_type) 
            errors.add(:vote_type, 'Vote type must be downvote or upvote')
        end
    end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/movies_controller.rb
class MoviesController < ApplicationController

    before_action :authenticate_user!

    attr_accessor :movies_facade

    def initialize
        super
        @user_vote_policy = UserVotePolicy.new
        @movies_facade = MoviesFacade.new
    end

    def index        
        @movies = @movies_facade.movies 

        @remaining_votes = @user_vote_policy.remaining_votes current_user
       
    end

    def ranking
        @movies = @movies_facade.movies_ranked
        @best_movies = @movies.first(MoviePolicies.number_of_best_movies_to_show)
    end   

    def details
        episode_id = params[:episode]

        @movie = @movies_facade.movie episode_id

        @movie["character_details"] = @movies_facade.characters @movie
        @movie["planet_details"] = @movies_facade.planets @movie

        # this is a good candidate for ajax, because the requests lock the server for too long
    end
  
end

app/controllers/votes_controller.rb
class VotesController < ApplicationController

    before_action :authenticate_user!

    rescue_from ActionController::InvalidAuthenticityToken, with: :handle_csrf_error

    def initialize
        super
        @user_vote_policy = UserVotePolicy.new
    end

    def vote
        movie_id = params[:movie_id]
        vote_type = params[:vote_type]
      
        
        if compute_vote(movie_id, vote_type)
            flash[:notice] = "Voto computado!"
        else
            flash[:error] = "Houve algum erro computando seu voto. :("
        end

        redirect_to root_url
    end

    def handle_csrf_error
        flash[:error] = "Falha em checar autenticidade do voto. Tente novamente."
        redirect_to root_url
    end

    def compute_vote(movie_id, vote_type)
        VotingService.new(@user_vote_policy).compute_vote movie_id, vote_type, current_user
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/movies_helper.rb
module MoviesHelper

    def user_can_vote?(movie)
        vote_policy = UserVotePolicy.new

        !Vote.exists?(user: current_user, movie_id: movie['episode_id']) && vote_policy.has_votes_left?(current_user)
        
    end
end

app/helpers/votes_helper.rb
module VotesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TrayRubyTestMovieRating</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
   <%= nav_bar brand: "Tray-Star Wars-IMDB", brand_link: root_url, responsive: true do %>
      <%= menu_group do %>
        <%= menu_item "Lista de filmes",  movies_index_path %>
        <%= menu_item "Ranking", movies_ranking_path %>
      <% end %>

      <p class="navbar-text pull-right">
        <% if user_signed_in? %>
          Logado como <strong><%= current_user.email %></strong>.
          <%= link_to 'Editar perfil', edit_user_registration_path, :class => 'navbar-link' %> |
          <%= link_to "Sair", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
        <% else %>
          <%= link_to "Cadastrar", new_user_registration_path, :class => 'navbar-link'  %> |
          <%= link_to "Login", new_user_session_path, :class => 'navbar-link'  %>
        <% end %>
      </p>
    <% end # nav_bar %>
    <div class="container">
      <% if alert %>
      <p class="alert alert-danger"><%= alert %></p>
    <% end %>
    </div>
    <%= yield %>
  </body>
</html>

app/views/movies/details.html.erb
<div class="container">
    <h1><%= @movie["title"] %></h1>

    <div>
        <p>Diretor: <%= @movie["director"] %></p>
        <p>Lançamento: <%= @movie["release_date"] %></p>
        <p>Sinopse: 
            <%= @movie["opening_crawl"] %>
        </p> 

        <p>Personagens: 
        <ul>
            <% @movie["character_details"].each do |character| %>
                <p>
                    <%= character["name"] %>
                </p>
            <% end %>
        </ul>
        </p>

        <p>Planetas: 
        <ul>
            <% @movie["planet_details"].each do |planet| %>
                <p>
                    <%= planet["name"] %>
                </p>
            <% end %>
        </ul>
        </p>

    </div> 
            
</div>

app/views/movies/index.html.erb
<div class="container">
    <% if flash[:notice] %>
        <div class="alert alert-success" role="alert">
            <%= flash[:notice] %>
        </div>
        <hr>
    <% end %>
    <% if flash[:error] %>
        <div class="alert alert-danger" role="alert">
            <%= flash[:error] %>
        </div>
        <hr>
    <% end %>

    <p class="alert alert-success">
        Você tem <%= @remaining_votes %> voto(s) restante(s)!
       
    </p>
     <% if @remaining_votes <= 0 %>
        <p class="alert alert-warning">
            Você já usou todos seus votos.
        </p>
    <% end %>
   
    <table class="table table-hover table-bordered">
        <thead>
            <tr>
                <td>Título</td>
                <td>Diretor</td>
                <td>Episódio</td>
                <td>Ano de lançamento</td>
                <td>Seu voto</td>
            </tr>
        </thead>
        <tbody>
            <% @movies.each do |movie| %>
            <tr>
                <td><%= movie["title"] %></td>
                <td><%= movie["director"] %></td>
                <td><%= movie["episode_id"] %></td>
                <td><%= movie["release_date"].to_date.year %></td>
                <td>
                    <%= button_to "vote", { 
                        params: {
                            vote_type: "upvote", 
                            movie_id: movie["episode_id"], 
                        },
                        controller:"votes",
                        disabled: !user_can_vote?(movie),
                        class: "btn-success btn btn-sm",
                        form_class: "aformclass"
                        } do %>
                        <img src="<%= image_url("heart-white-40px.png") %>" alt="" width="20px" height="20px">
                    <% end %>
                    <%= button_to "vote", { 
                        params: {
                            vote_type: "downvote", 
                            movie_id: movie["episode_id"], 
                        },
                        controller:"votes",
                        disabled: !user_can_vote?(movie),
                        class: "btn-danger btn btn-sm",
                        form_class: "aformclass"
                        } do %>
                        <img src="<%= image_url("heart-white-broken-40px.png") %>" alt="" width="20px" height="20px">
                    <% end %>
                </td>
            </tr> 
            <% end %>
        </tbody>
    </table>
</div>

app/views/movies/ranking.html.erb
<div class="container">
    <h3>Melhores filmes na opinião dos usuários</h3>
    <ul>
        <% @best_movies.each do |movie| %>
        <li>
            <%= link_to "ranking/#{movie["episode_id"]}" do %>
                 <%= movie["title"] %>
            <% end %>
        </li>
        <% end %>
    </ul>
    <hr>

    <table class="table table-hover table-bordered">
        <thead>
            <tr>
                <td>Título</td>
                <td>Diretor</td>
                <td>Episódio</td>
                <td>Ano de lançamento</td>
                <td>Ranking</td>
            </tr>
        </thead>
        <tbody>
            <% @movies.each do |movie| %>
            <tr>
                <td><%= movie["title"] %></td>
                <td><%= movie["director"] %></td>
                <td><%= movie["episode_id"] %></td>
                <td><%= movie["release_date"].to_date.year %></td>
                <td><%= movie["ranking"] %></td>
            </tr> 
            <% end %>
        </tbody>
    </table>
</div>